"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.arduinoInfo = void 0;
const vscode = __importStar(require("vscode"));
class arduinoInfo {
    constructor() {
        const arduinoContext = vscode.extensions.getExtension('dankeboy36.vscode-arduino-api')?.exports;
        if (!arduinoContext) {
            // Failed to load the Arduino API.
            return;
        }
        vscode.window.showInformationMessage(`Sketch path: ${arduinoContext.sketchPath}`);
        arduinoContext.onDidChange('fqbn')((fqbn) => vscode.window.showInformationMessage(`FQBN: ${fqbn}`));
        arduinoContext.onDidChange('port')((port) => {
            vscode.window.showInformationMessage(`port: ${port?.address} ${port?.hardwareId} ${port?.label} ${port?.properties} ${port?.protocol} ${port?.protocolLabel}`);
            for (const key in port?.properties) {
                const value = port.properties[key];
                vscode.window.showInformationMessage(key + ' ' + value);
            }
        });
    }
}
exports.arduinoInfo = arduinoInfo;
//# sourceMappingURL=arduino-info.js.map