"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.activate = void 0;
const vscode_1 = __importDefault(require("vscode"));
const terminal_1 = require("./terminal");
const udp_server_1 = require("./udp-server");
function activate(context) {
    findArduinoContext().then((arduinoContext) => {
        if (!arduinoContext) {
            vscode_1.default.window.showErrorMessage(`Could not find th '${vscodeArduinoAPI}' extension must be installed.`);
            return;
        }
        context.subscriptions.push(vscode_1.default.commands.registerCommand('HeltecEspNetworkMonitor.showTerminal', () => (0, terminal_1.opeTerminal)(), new udp_server_1.udpCommunication(arduinoContext)));
        // new arduinoInfo();
    });
}
exports.activate = activate;
async function findArduinoContext() {
    const apiExtension = findArduinoApiExtension();
    if (apiExtension && !apiExtension.isActive) {
        await apiExtension.activate();
    }
    return apiExtension?.exports;
}
const vscodeArduinoAPI = 'dankeboy36.vscode-arduino-api';
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function findArduinoApiExtension() {
    return vscode_1.default.extensions.getExtension(vscodeArduinoAPI);
}
//# sourceMappingURL=extension.js.map