"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.showMessageToTerminal = exports.opeTerminal = exports.Sleep = exports.channel = void 0;
const vscode = __importStar(require("vscode"));
const node_diagnostics_channel_1 = __importDefault(require("node:diagnostics_channel"));
exports.channel = node_diagnostics_channel_1.default.channel('udp-sendmessage');
const networkMonitorTerminalTitle = 'ESP Network Monitor';
const networkMonitorTerminalName = 'Network Monitor';
const Sleep = (ms) => {
    return new Promise(resolve => setTimeout(resolve, ms));
};
exports.Sleep = Sleep;
class NetworkMonitorTerminal {
    constructor() {
        this.onDidWriteEmitter = new vscode.EventEmitter();
        this.onDidCloseEmitter = new vscode.EventEmitter();
        this.toDispose = [
            this.onDidWriteEmitter,
            this.onDidCloseEmitter,
            new vscode.Disposable(() => this.abortController?.abort()),
        ];
        this.onDidWrite = this.onDidWriteEmitter.event;
        this.onDidClose = this.onDidCloseEmitter.event;
        this.inputStr = '';
    }
    open() {
        this.updateParams();
    }
    close() {
        vscode.Disposable.from(...this.toDispose).dispose();
    }
    handleInput(data) {
        const now = new Date();
        const hours = String(now.getHours()).padStart(2, '0');
        const minutes = String(now.getMinutes()).padStart(2, '0');
        const seconds = String(now.getSeconds()).padStart(2, '0');
        const milliseconds = String(now.getMilliseconds()).padStart(3, '0');
        const formattedTime = `${hours}:${minutes}:${seconds}.${milliseconds}`;
        if (data.startsWith('log') === false) {
            if (data.endsWith('\r')) {
                exports.channel.publish({
                    message: this.inputStr,
                });
                this.onDidWriteEmitter.fire('\r\n' + formattedTime + ': ' + this.inputStr);
                this.inputStr = '';
                return;
            }
            else {
                this.inputStr += data;
            }
        }
        else {
            data = data.slice(3);
        }
        // 格式化时间为 "15:22:25.303" 格式
        this.onDidWriteEmitter.fire('\r\n' + formattedTime + ': ' + data);
    }
    async updateParams() {
        // let params: DecodeTerminalState['params'];
        // try {
        //   params = await createDecodeParams(this.arduinoContext);
        // } catch (err) {
        //   params = err instanceof Error ? err : new Error(String(err));
        // }
        // this.updateState({ params });
    }
}
function opeTerminal() {
    const terminal = findDecodeTerminal() ?? createDecodeTerminal();
    terminal.show();
    return terminal;
}
exports.opeTerminal = opeTerminal;
function findDecodeTerminal() {
    return vscode.window.terminals.find((terminal) => terminal.name === networkMonitorTerminalName && terminal.exitStatus === undefined);
}
const pty = new NetworkMonitorTerminal();
function createDecodeTerminal() {
    const options = {
        name: networkMonitorTerminalName,
        pty,
        iconPath: new vscode.ThemeIcon('debug-console'),
    };
    return vscode.window.createTerminal(options);
}
function showMessageToTerminal(str) {
    pty.handleInput('log' + str);
}
exports.showMessageToTerminal = showMessageToTerminal;
//# sourceMappingURL=terminal.js.map