"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.udpCommunication = void 0;
const vscode = __importStar(require("vscode"));
const terminal_1 = require("./terminal");
const os_1 = __importDefault(require("os"));
const dgram_1 = __importDefault(require("dgram"));
class udpCommunication {
    constructor(arduinoContext) {
        this.arduinoContext = arduinoContext;
        this.remoteAddress = undefined;
        this.remotePort = undefined;
        this.server = dgram_1.default.createSocket("udp4");
        this.arduinoContext.onDidChange('port')((port) => {
            // vscode.window.showInformationMessage(`port: ${port?.address} ${port?.hardwareId} ${port?.label} ${port?.properties} ${port?.protocol} ${port?.protocolLabel}`)
            this.remoteAddress = port?.address;
            for (const key in port?.properties) {
                if (key === 'udp_port') {
                    this.remotePort = port.properties[key];
                    // vscode.window.showInformationMessage(key +' '+ value);
                }
            }
            vscode.window.showInformationMessage(this.remotePort + 'this.remoteAddress' + this.remoteAddress);
            if (this.remoteAddress !== undefined) {
                this.closeUDPServer();
                this.createUDPServer();
            }
            //  this.closeUDPServer();
            // this.createUDPServer();
        });
        this.createUDPServer();
    }
    getIPV4Address(routeMatch) {
        const interfaces = os_1.default.networkInterfaces();
        for (const devName in interfaces) {
            console.log(devName);
            const iface = interfaces[devName];
            console.log(iface);
            for (let i = 0; ((iface !== undefined) && (i < iface.length)); i++) {
                let alias = iface[i];
                console.log(alias);
                if (alias.family === 'IPv4' && alias.address !== '127.0.0.1' && !alias.internal) {
                    if (alias.address.indexOf(routeMatch) !== -1) {
                        return alias.address;
                        vscode.window.showInformationMessage("IP:" + alias.address);
                    }
                }
            }
        }
        return undefined;
    }
    createUDPServer() {
        this.server = dgram_1.default.createSocket("udp4");
        vscode.window.showInformationMessage('createUDPServer');
        this.server.on("message", (msg, rinfo) => {
            console.log("rinfo.address =  " + rinfo.address);
            console.log("rinfo.port =  " + rinfo.port);
            console.log(msg.toString());
            // setTimeout(() => {
            //     showMessageToTerminal(msg.toString());
            //   }, 1000);
            (0, terminal_1.showMessageToTerminal)(msg.toString());
        });
        this.server.on("listening", () => {
            console.log("address:" + this.server.address().address);
            console.log("port:" + this.server.address().port);
            vscode.window.showInformationMessage("address:" + this.server.address().address);
            vscode.window.showInformationMessage("port:" + this.server.address().port);
            setTimeout(() => {
                (0, terminal_1.showMessageToTerminal)("listening address:" + this.server.address().address + '\r\n');
            }, 1000);
            setTimeout(() => {
                (0, terminal_1.showMessageToTerminal)("listening port:" + this.server.address().port + '\r\n');
            }, 1000);
        });
        this.server.on('error', (err) => {
            vscode.window.showErrorMessage(`server error:\n${err.stack}`);
            this.server.close();
        });
        // this.server.bind(0);
        if (this.remoteAddress !== undefined) {
            this.server.bind(0, this.getIPV4Address(this.remoteAddress));
        }
        else {
            this.server.bind(0);
        }
    }
    // 关闭UDP服务器
    closeUDPServer() {
        if (this.server) {
            vscode.window.showInformationMessage('UDP Server closed');
            this.server?.close(() => {
                vscode.window.showInformationMessage('UDP Server close212d');
            });
        }
    }
}
exports.udpCommunication = udpCommunication;
//# sourceMappingURL=udp.js.map